//===----------------------------------------------------------------------===//
// This file is automatically generated by scripts/generate_serialization.py
// Do not edit this file manually, your changes will be overwritten
//===----------------------------------------------------------------------===//

#include "duckdb/common/serializer/format_serializer.hpp"
#include "duckdb/common/serializer/format_deserializer.hpp"
#include "buffered_json_reader.hpp"
#include "json_transform.hpp"
#include "json_scan.hpp"

namespace duckdb {

void BufferedJSONReaderOptions::FormatSerialize(FormatSerializer &serializer) const {
	serializer.WriteProperty(100, "format", format);
	serializer.WriteProperty(101, "record_type", record_type);
	serializer.WriteProperty(102, "compression", compression);
	serializer.WriteProperty(103, "file_options", file_options);
}

BufferedJSONReaderOptions BufferedJSONReaderOptions::FormatDeserialize(FormatDeserializer &deserializer) {
	BufferedJSONReaderOptions result;
	deserializer.ReadProperty(100, "format", result.format);
	deserializer.ReadProperty(101, "record_type", result.record_type);
	deserializer.ReadProperty(102, "compression", result.compression);
	deserializer.ReadProperty(103, "file_options", result.file_options);
	return result;
}

void JSONScanData::FormatSerialize(FormatSerializer &serializer) const {
	serializer.WriteProperty(100, "json_type", type);
	serializer.WriteProperty(101, "options", options);
	serializer.WriteProperty(102, "reader_bind", reader_bind);
	serializer.WriteProperty(103, "files", files);
	serializer.WriteProperty(104, "ignore_errors", ignore_errors);
	serializer.WriteProperty(105, "maximum_object_size", maximum_object_size);
	serializer.WriteProperty(106, "auto_detect", auto_detect);
	serializer.WriteProperty(107, "sample_size", sample_size);
	serializer.WriteProperty(108, "max_depth", max_depth);
	serializer.WriteProperty(109, "transform_options", transform_options);
	serializer.WriteProperty(110, "names", names);
	serializer.WriteProperty(111, "date_format", GetDateFormat());
	serializer.WriteProperty(112, "timestamp_format", GetTimestampFormat());
}

unique_ptr<JSONScanData> JSONScanData::FormatDeserialize(FormatDeserializer &deserializer) {
	auto type = deserializer.ReadProperty<JSONScanType>(100, "json_type");
	auto options = deserializer.ReadProperty<BufferedJSONReaderOptions>(101, "options");
	auto reader_bind = deserializer.ReadProperty<MultiFileReaderBindData>(102, "reader_bind");
	auto files = deserializer.ReadProperty<vector<string>>(103, "files");
	auto ignore_errors = deserializer.ReadProperty<bool>(104, "ignore_errors");
	auto maximum_object_size = deserializer.ReadProperty<idx_t>(105, "maximum_object_size");
	auto auto_detect = deserializer.ReadProperty<bool>(106, "auto_detect");
	auto sample_size = deserializer.ReadProperty<idx_t>(107, "sample_size");
	auto max_depth = deserializer.ReadProperty<idx_t>(108, "max_depth");
	auto transform_options = deserializer.ReadProperty<JSONTransformOptions>(109, "transform_options");
	auto names = deserializer.ReadProperty<vector<string>>(110, "names");
	auto date_format = deserializer.ReadProperty<string>(111, "date_format");
	auto timestamp_format = deserializer.ReadProperty<string>(112, "timestamp_format");
	auto result = duckdb::unique_ptr<JSONScanData>(new JSONScanData(deserializer.Get<ClientContext &>(), std::move(files), std::move(date_format), std::move(timestamp_format)));
	result->type = type;
	result->options = options;
	result->reader_bind = reader_bind;
	result->ignore_errors = ignore_errors;
	result->maximum_object_size = maximum_object_size;
	result->auto_detect = auto_detect;
	result->sample_size = sample_size;
	result->max_depth = max_depth;
	result->transform_options = transform_options;
	result->names = std::move(names);
	return result;
}

void JSONTransformOptions::FormatSerialize(FormatSerializer &serializer) const {
	serializer.WriteProperty(100, "strict_cast", strict_cast);
	serializer.WriteProperty(101, "error_duplicate_key", error_duplicate_key);
	serializer.WriteProperty(102, "error_missing_key", error_missing_key);
	serializer.WriteProperty(103, "error_unknown_key", error_unknown_key);
	serializer.WriteProperty(104, "delay_error", delay_error);
}

JSONTransformOptions JSONTransformOptions::FormatDeserialize(FormatDeserializer &deserializer) {
	JSONTransformOptions result;
	deserializer.ReadProperty(100, "strict_cast", result.strict_cast);
	deserializer.ReadProperty(101, "error_duplicate_key", result.error_duplicate_key);
	deserializer.ReadProperty(102, "error_missing_key", result.error_missing_key);
	deserializer.ReadProperty(103, "error_unknown_key", result.error_unknown_key);
	deserializer.ReadProperty(104, "delay_error", result.delay_error);
	return result;
}

} // namespace duckdb
