//===----------------------------------------------------------------------===//
// This file is automatically generated by scripts/generate_serialization.py
// Do not edit this file manually, your changes will be overwritten
//===----------------------------------------------------------------------===//

#include "duckdb/common/serializer/format_serializer.hpp"
#include "duckdb/common/serializer/format_deserializer.hpp"
#include "duckdb/parser/parsed_data/create_info.hpp"
#include "duckdb/parser/parsed_data/create_index_info.hpp"
#include "duckdb/parser/parsed_data/create_table_info.hpp"
#include "duckdb/parser/parsed_data/create_schema_info.hpp"
#include "duckdb/parser/parsed_data/create_view_info.hpp"
#include "duckdb/parser/parsed_data/create_type_info.hpp"
#include "duckdb/parser/parsed_data/create_macro_info.hpp"
#include "duckdb/parser/parsed_data/create_sequence_info.hpp"

namespace duckdb {

void CreateInfo::FormatSerialize(FormatSerializer &serializer) const {
	serializer.WriteProperty(100, "type", type);
	serializer.WriteProperty(101, "catalog", catalog);
	serializer.WriteProperty(102, "schema", schema);
	serializer.WriteProperty(103, "temporary", temporary);
	serializer.WriteProperty(104, "internal", internal);
	serializer.WriteProperty(105, "on_conflict", on_conflict);
	serializer.WriteProperty(106, "sql", sql);
}

unique_ptr<CreateInfo> CreateInfo::FormatDeserialize(FormatDeserializer &deserializer) {
	auto type = deserializer.ReadProperty<CatalogType>(100, "type");
	auto catalog = deserializer.ReadProperty<string>(101, "catalog");
	auto schema = deserializer.ReadProperty<string>(102, "schema");
	auto temporary = deserializer.ReadProperty<bool>(103, "temporary");
	auto internal = deserializer.ReadProperty<bool>(104, "internal");
	auto on_conflict = deserializer.ReadProperty<OnCreateConflict>(105, "on_conflict");
	auto sql = deserializer.ReadProperty<string>(106, "sql");
	unique_ptr<CreateInfo> result;
	switch (type) {
	case CatalogType::INDEX_ENTRY:
		result = CreateIndexInfo::FormatDeserialize(deserializer);
		break;
	case CatalogType::MACRO_ENTRY:
		result = CreateMacroInfo::FormatDeserialize(deserializer);
		break;
	case CatalogType::SCHEMA_ENTRY:
		result = CreateSchemaInfo::FormatDeserialize(deserializer);
		break;
	case CatalogType::SEQUENCE_ENTRY:
		result = CreateSequenceInfo::FormatDeserialize(deserializer);
		break;
	case CatalogType::TABLE_ENTRY:
		result = CreateTableInfo::FormatDeserialize(deserializer);
		break;
	case CatalogType::TABLE_MACRO_ENTRY:
		result = CreateMacroInfo::FormatDeserialize(deserializer);
		break;
	case CatalogType::TYPE_ENTRY:
		result = CreateTypeInfo::FormatDeserialize(deserializer);
		break;
	case CatalogType::VIEW_ENTRY:
		result = CreateViewInfo::FormatDeserialize(deserializer);
		break;
	default:
		throw SerializationException("Unsupported type for deserialization of CreateInfo!");
	}
	result->catalog = std::move(catalog);
	result->schema = std::move(schema);
	result->temporary = temporary;
	result->internal = internal;
	result->on_conflict = on_conflict;
	result->sql = std::move(sql);
	return result;
}

void CreateIndexInfo::FormatSerialize(FormatSerializer &serializer) const {
	CreateInfo::FormatSerialize(serializer);
	serializer.WriteProperty(200, "name", index_name);
	serializer.WriteProperty(201, "table", table);
	serializer.WriteProperty(202, "index_type", index_type);
	serializer.WriteProperty(203, "constraint_type", constraint_type);
	serializer.WriteProperty(204, "parsed_expressions", parsed_expressions);
	serializer.WriteProperty(205, "names", names);
	serializer.WriteProperty(206, "column_ids", column_ids);
}

unique_ptr<CreateInfo> CreateIndexInfo::FormatDeserialize(FormatDeserializer &deserializer) {
	auto result = duckdb::unique_ptr<CreateIndexInfo>(new CreateIndexInfo());
	deserializer.ReadProperty(200, "name", result->index_name);
	deserializer.ReadProperty(201, "table", result->table);
	deserializer.ReadProperty(202, "index_type", result->index_type);
	deserializer.ReadProperty(203, "constraint_type", result->constraint_type);
	deserializer.ReadProperty(204, "parsed_expressions", result->parsed_expressions);
	deserializer.ReadProperty(205, "names", result->names);
	deserializer.ReadProperty(206, "column_ids", result->column_ids);
	return std::move(result);
}

void CreateMacroInfo::FormatSerialize(FormatSerializer &serializer) const {
	CreateInfo::FormatSerialize(serializer);
	serializer.WriteProperty(200, "name", name);
	serializer.WriteProperty(201, "function", *function);
}

unique_ptr<CreateInfo> CreateMacroInfo::FormatDeserialize(FormatDeserializer &deserializer) {
	auto result = duckdb::unique_ptr<CreateMacroInfo>(new CreateMacroInfo());
	deserializer.ReadProperty(200, "name", result->name);
	deserializer.ReadProperty(201, "function", result->function);
	return std::move(result);
}

void CreateSchemaInfo::FormatSerialize(FormatSerializer &serializer) const {
	CreateInfo::FormatSerialize(serializer);
}

unique_ptr<CreateInfo> CreateSchemaInfo::FormatDeserialize(FormatDeserializer &deserializer) {
	auto result = duckdb::unique_ptr<CreateSchemaInfo>(new CreateSchemaInfo());
	return std::move(result);
}

void CreateSequenceInfo::FormatSerialize(FormatSerializer &serializer) const {
	CreateInfo::FormatSerialize(serializer);
	serializer.WriteProperty(200, "name", name);
	serializer.WriteProperty(201, "usage_count", usage_count);
	serializer.WriteProperty(202, "increment", increment);
	serializer.WriteProperty(203, "min_value", min_value);
	serializer.WriteProperty(204, "max_value", max_value);
	serializer.WriteProperty(205, "start_value", start_value);
	serializer.WriteProperty(206, "cycle", cycle);
}

unique_ptr<CreateInfo> CreateSequenceInfo::FormatDeserialize(FormatDeserializer &deserializer) {
	auto result = duckdb::unique_ptr<CreateSequenceInfo>(new CreateSequenceInfo());
	deserializer.ReadProperty(200, "name", result->name);
	deserializer.ReadProperty(201, "usage_count", result->usage_count);
	deserializer.ReadProperty(202, "increment", result->increment);
	deserializer.ReadProperty(203, "min_value", result->min_value);
	deserializer.ReadProperty(204, "max_value", result->max_value);
	deserializer.ReadProperty(205, "start_value", result->start_value);
	deserializer.ReadProperty(206, "cycle", result->cycle);
	return std::move(result);
}

void CreateTableInfo::FormatSerialize(FormatSerializer &serializer) const {
	CreateInfo::FormatSerialize(serializer);
	serializer.WriteProperty(200, "table", table);
	serializer.WriteProperty(201, "columns", columns);
	serializer.WriteProperty(202, "constraints", constraints);
	serializer.WriteOptionalProperty(203, "query", query);
}

unique_ptr<CreateInfo> CreateTableInfo::FormatDeserialize(FormatDeserializer &deserializer) {
	auto result = duckdb::unique_ptr<CreateTableInfo>(new CreateTableInfo());
	deserializer.ReadProperty(200, "table", result->table);
	deserializer.ReadProperty(201, "columns", result->columns);
	deserializer.ReadProperty(202, "constraints", result->constraints);
	deserializer.ReadOptionalProperty(203, "query", result->query);
	return std::move(result);
}

void CreateTypeInfo::FormatSerialize(FormatSerializer &serializer) const {
	CreateInfo::FormatSerialize(serializer);
	serializer.WriteProperty(200, "name", name);
	serializer.WriteProperty(201, "logical_type", type);
}

unique_ptr<CreateInfo> CreateTypeInfo::FormatDeserialize(FormatDeserializer &deserializer) {
	auto result = duckdb::unique_ptr<CreateTypeInfo>(new CreateTypeInfo());
	deserializer.ReadProperty(200, "name", result->name);
	deserializer.ReadProperty(201, "logical_type", result->type);
	return std::move(result);
}

void CreateViewInfo::FormatSerialize(FormatSerializer &serializer) const {
	CreateInfo::FormatSerialize(serializer);
	serializer.WriteProperty(200, "view_name", view_name);
	serializer.WriteProperty(201, "aliases", aliases);
	serializer.WriteProperty(202, "types", types);
	serializer.WriteOptionalProperty(203, "query", query);
}

unique_ptr<CreateInfo> CreateViewInfo::FormatDeserialize(FormatDeserializer &deserializer) {
	auto result = duckdb::unique_ptr<CreateViewInfo>(new CreateViewInfo());
	deserializer.ReadProperty(200, "view_name", result->view_name);
	deserializer.ReadProperty(201, "aliases", result->aliases);
	deserializer.ReadProperty(202, "types", result->types);
	deserializer.ReadOptionalProperty(203, "query", result->query);
	return std::move(result);
}

} // namespace duckdb
